//
//  HorizontalGrideView.h
//  HorizontalGrideView
//
//  Created by Vivitickey on 2017/5/17.
//  Copyright © 2017年 test. All rights reserved.
//

#import <UIKit/UIKit.h>
@class HorizontalGrideView;

@protocol HorizontalGrideViewDataSource <NSObject>

@optional
/**
 提供数据的数量
 
 @param horizontalGrideView 控件本身
 @return 返回数量
 */
- (NSInteger)numberOfItemsInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView;


/**
 提供选项标题
 
 @param horizontalGrideView 当前控件
 @param index 选项下标
 @return 返回标题
 */
- (NSString *)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView titleForItemAtIndex:(NSInteger)index;


/**
 提供选项的图标地址路径
 
 @param horizontalGrideView 当前控件
 @param index 选项下标
 @return 返回图标路径
 */
- (NSURL *)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView iconURLForItemAtIndex:(NSInteger)index;

@end

@protocol HorizontalGrideViewDelegate <NSObject>

@optional
/**
 设置每页的行数 默认 2
 
 @param horizontalGrideView 当前控件
 @return 行数
 */
- (NSInteger)numberOfRowsPerPageInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView;


/**
 设置每页的列数 默认 4
 
 @param horizontalGrideView 当前控件
 @return 列数
 */
- (NSInteger)numberOfColumnsPerPageInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView;

/**
 当选项被点击回调
 
 @param horizontalGrideView 当前控件
 @param index 点击下标
 */
- (void)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView didSelectItemAtIndex:(NSInteger)index;

/**
 返回当前选中的pageControl 颜色
 
 @param horizontalGrideView 当前控件
 @return 颜色
 */
- (UIColor *)colorForCurrentPageControlInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView;
@end
@interface HorizontalGrideView : UIView

@property (weak, nonatomic) id<HorizontalGrideViewDataSource>   dataSource;

@property (weak, nonatomic) id<HorizontalGrideViewDelegate>     delegate;

@property (strong, nonatomic)   UIImage                         *defaultImage;

/**
 刷新
 */
- (void)reloadData;

@end
