//
//  ViewController.m
//  HorizontalGrideView
//
//  Created by Vivitickey on 2017/5/17.
//  Copyright © 2017年 test. All rights reserved.
//

#import "ViewController.h"
#import "HorizontalGrideView.h"
#import <Masonry/Masonry.h>
@interface ViewController ()<HorizontalGrideViewDelegate,HorizontalGrideViewDataSource>

@property (strong,nonatomic) HorizontalGrideView *horizontalGrideView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.horizontalGrideView = [HorizontalGrideView new];
    
    [self.view addSubview:self.horizontalGrideView];
    
    [self.horizontalGrideView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.right.equalTo(self.view);
        make.top.mas_equalTo(100);
        make.height.mas_equalTo(300);
    }];
    
    self.horizontalGrideView.dataSource = self;
    self.horizontalGrideView.delegate = self;
    
    [self.horizontalGrideView reloadData];
    
}

#pragma mark - HorizontalGrideViewDataSource -
/**
 提供数据的数量
 
 @param horizontalGrideView 控件本身
 @return 返回数量
 */
- (NSInteger)numberOfItemsInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView {
    return 100;//arc4random_uniform(100);
}


/**
 提供选项标题
 
 @param horizontalGrideView 当前控件
 @param index 选项下标
 @return 返回标题
 */
- (NSString *)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView titleForItemAtIndex:(NSInteger)index {
    return [NSString stringWithFormat:@"item %zd",index];
}


/**
 提供选项的图标地址路径
 
 @param horizontalGrideView 当前控件
 @param index 选项下标
 @return 返回图标路径
 */
- (NSURL *)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView iconURLForItemAtIndex:(NSInteger)index {
    return [NSURL URLWithString:@"https://staticlive.douyucdn.cn/upload/game_cate/f719087663581b7a723c4d39f8721bc1.jpg"];
}

#pragma mark - HorizontalGrideViewDelegate -
/**
 设置每页的行数 默认 2
 
 @param horizontalGrideView 当前控件
 @return 行数
 */
- (NSInteger)numberOfRowsPerPageInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView {
    return 4;
}


/**
 设置每页的列数 默认 4
 
 @param horizontalGrideView 当前控件
 @return 列数
 */
- (NSInteger)numberOfColumnsPerPageInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView {
    return 5;
}

/**
 当选项被点击回调
 
 @param horizontalGrideView 当前控件
 @param index 点击下标
 */
- (void)horizontalGrideView:(HorizontalGrideView *)horizontalGrideView didSelectItemAtIndex:(NSInteger)index {
    NSLog(@"item %zd 被点击",index);
}

/**
 返回当前选中的pageControl 颜色
 
 @param horizontalGrideView 当前控件
 @return 颜色
 */
- (UIColor *)colorForCurrentPageControlInHorizontalGrideView:(HorizontalGrideView *)horizontalGrideView {
    return [UIColor orangeColor];
}


@end
